diff --git a/src/backend/utils/sort/batchstore.c b/src/backend/utils/sort/batchstore.c
new file mode 100644
index 0000000000..4578c718d3
--- /dev/null
+++ b/src/backend/utils/sort/batchstore.c
@@ -0,0 +1,466 @@
+#include "postgres.h"
+
+#include "access/htup_details.h"
+#include "access/parallel.h"
+#include "commands/tablespace.h"
+#include "executor/nodeHash.h"
+#include "port/atomics.h"
+#include "storage/buffile.h"
+#include "utils/batchstore.h"
+#include "utils/memutils.h"
+#include "utils/sharedtuplestore.h"
+
+#define InvalidBatch UINT32_MAX
+
+typedef enum BatchMethod
+{
+	BSM_HASH = 1,
+	BSM_PARALLEL_HASH
+}BatchMethod;
+
+typedef struct BatchStoreParallelHashData
+{
+	pg_atomic_uint32	cur_batches;
+	uint32				num_batches;
+	uint32				num_participants;
+}BatchStoreParallelHashData;
+
+typedef struct BatchStoreData
+{
+	BatchStoreFuncs	func;
+	BatchMethod	method;
+	uint32		num_batches;
+	void	   *cur_batch_ptr;
+	uint32		cur_batch_num;
+	union
+	{
+		/* for hash */
+		struct
+		{
+			StringInfoData	hash_read_buf;
+		};
+		/* for parallel hash */
+		struct
+		{
+			dsm_segment		   *dsm_seg;
+			MemoryContext		accessor_mcontext;
+			/* in shared memory, next idle parallel hash batch number */
+			pg_atomic_uint32   *shm_ph_batch_num;
+		};
+	};
+	void	 *all_batches[FLEXIBLE_ARRAY_MEMBER];
+}BatchStoreData;
+
+static void bs_write_normal_hash(BatchStore bs, MinimalTuple mtup, uint32 hash);
+static MinimalTuple bs_read_normal_hash(BatchStore bs, uint32 *hash);
+
+static void bs_write_parallel_hash(BatchStore bs, MinimalTuple mtup, uint32 hash);
+static void bs_write_parallel_one_batch_hash(BatchStore bs, MinimalTuple mtup, uint32 hash);
+static MinimalTuple bs_read_parallel_hash(BatchStore bs, uint32 *hash);
+
+/*
+ * make an empty batch store
+ */
+static inline BatchStore
+make_empty_batch_store(uint32 num_batches, BatchMethod method)
+{
+	BatchStore bs = palloc0(offsetof(BatchStoreData, all_batches) +
+								sizeof(void*) * num_batches);
+
+	bs->method = method;
+	bs->num_batches = num_batches;
+	bs->cur_batch_num = InvalidBatch;
+
+	return bs;
+}
+
+/*
+ * Create a normal batch store
+ */
+BatchStore
+bs_begin_hash(uint32 num_batches)
+{
+	BatchStore bs = make_empty_batch_store(num_batches, BSM_HASH);
+
+	/* Initialize hash read buffer for MinimalTuple */
+	initStringInfo(&bs->hash_read_buf);
+	enlargeStringInfo(&bs->hash_read_buf, MINIMAL_TUPLE_DATA_OFFSET);
+	MemSet(bs->hash_read_buf.data, 0, MINIMAL_TUPLE_DATA_OFFSET);
+
+	PrepareTempTablespaces();
+
+	bs->func.hash_write = bs_write_normal_hash;
+	bs->func.hash_read = bs_read_normal_hash;
+	return bs;
+}
+
+size_t
+bs_parallel_hash_estimate(uint32 num_batches, uint32 nparticipants)
+{
+	return MAXALIGN(sizeof(struct BatchStoreParallelHashData)) +
+				MAXALIGN(sts_estimate(nparticipants)) * num_batches;
+}
+
+/*
+ * Create or attach shared batch store
+ */
+static BatchStore
+bs_begin_parallel_hash(BatchStoreParallelHash bsph,
+					   uint32 my_participant_num, bool init,
+					   SharedFileSet *fileset, const char *name,
+					   dsm_segment *dsm_seg)
+{
+	uint32			i;
+	MemoryContext	oldcontext;
+	char		   *addr;
+	char			buffer[24];
+	Size			sts_size = MAXALIGN(sts_estimate(bsph->num_participants));
+	BatchStore		bs = make_empty_batch_store(bsph->num_batches, BSM_PARALLEL_HASH);
+
+	bs->shm_ph_batch_num = &bsph->cur_batches;
+
+	bs->accessor_mcontext = AllocSetContextCreate(CurrentMemoryContext,
+												  "batch parallel hash",
+												  ALLOCSET_DEFAULT_SIZES);
+	oldcontext = MemoryContextSwitchTo(bs->accessor_mcontext);
+	addr = ((char*)bsph) + MAXALIGN(sizeof(*bsph));
+	for (i=bsph->num_batches;i>0;)
+	{
+		--i;
+		if (init)
+		{
+			sprintf(buffer, "%s_%u", name, i);
+			bs->all_batches[i] = sts_initialize((SharedTuplestore*)addr,
+												bsph->num_participants,
+												my_participant_num,
+												sizeof(uint32),
+												0,
+												fileset,
+												buffer);
+		}else
+		{
+			bs->all_batches[i] = sts_attach((SharedTuplestore*)addr,
+											my_participant_num,
+											fileset);
+		}
+		addr += sts_size;
+	}
+	MemoryContextSwitchTo(oldcontext);
+
+	bs->dsm_seg = dsm_seg;
+	bs->func.hash_read = bs_read_parallel_hash;
+	if (bs->num_batches == 1)
+		bs->func.hash_write = bs_write_parallel_one_batch_hash;
+	else
+		bs->func.hash_write = bs_write_parallel_hash;
+
+	return bs;
+}
+
+/*
+ * Create a parallel batch store
+ */
+BatchStore
+bs_init_parallel_hash(uint32 num_batches,
+					  uint32 nparticipants, uint32 my_participant_num,
+					  BatchStoreParallelHash bsph, dsm_segment *dsm_seg,
+					  SharedFileSet *fileset, const char *name)
+{
+	Assert(name != NULL && fileset != NULL);
+	bsph->num_batches = num_batches;
+	bsph->num_participants = nparticipants;
+	pg_atomic_init_u32(&bsph->cur_batches, InvalidBatch);
+
+	return bs_begin_parallel_hash(bsph, my_participant_num, true, fileset, name, dsm_seg);
+}
+
+/*
+ * Attach from parallel batch store
+ */
+BatchStore
+bs_attach_parallel_hash(BatchStoreParallelHash bsph, dsm_segment *dsm_seg,
+						SharedFileSet *fileset, uint32 my_participant_num)
+{
+	return bs_begin_parallel_hash(bsph, my_participant_num, false, fileset, NULL, dsm_seg);
+}
+
+/* Destory batch store */
+void
+bs_destory(BatchStore bs)
+{
+	uint32	i;
+	if (bs == NULL)
+		return;
+
+	switch(bs->method)
+	{
+	case BSM_HASH:
+		for(i=0;i<bs->num_batches;++i)
+		{
+			if (bs->all_batches[i])
+				BufFileClose(bs->all_batches[i]);
+		}
+		pfree(bs->hash_read_buf.data);
+		break;
+	case BSM_PARALLEL_HASH:
+		{
+			BatchStoreParallelHash bsph = (BatchStoreParallelHash)(((char*)bs->shm_ph_batch_num) -
+											offsetof(BatchStoreParallelHashData, cur_batches));
+			uint32 count = bsph->num_batches;
+			while (count > 0)
+				sts_detach(bs->all_batches[--count]);
+			MemoryContextDelete(bs->accessor_mcontext);
+		}
+		break;
+	default:
+		ereport(ERROR,
+				(errmsg("unknown batch store method %u", bs->method)));
+		break;
+	}
+
+	pfree(bs);
+}
+
+/*
+ * Write MinimalTuple and hash value to normal batch store
+ */
+static void
+bs_write_normal_hash(BatchStore bs, MinimalTuple mtup, uint32 hash)
+{
+	uint32 batch = hash % bs->num_batches;
+	uint32 data_len = mtup->t_len - MINIMAL_TUPLE_DATA_OFFSET;
+	BufFile *buffile = bs->all_batches[batch];
+
+	if (unlikely(buffile == NULL))
+	{
+		MemoryContext oldcontext = MemoryContextSwitchTo(GetMemoryChunkContext(bs));
+		buffile = BufFileCreateTemp(false);
+		bs->all_batches[batch] = buffile;
+		MemoryContextSwitchTo(oldcontext);
+	}
+
+	BufFileWrite(buffile, &hash, sizeof(hash));
+	BufFileWrite(buffile, &mtup->t_len, sizeof(mtup->t_len));
+	BufFileWrite(buffile, ((char*)mtup) + MINIMAL_TUPLE_DATA_OFFSET, data_len);
+}
+
+/*
+ * Read MinimalTuple and hash value from normal batch store
+ */
+static MinimalTuple
+bs_read_normal_hash(BatchStore bs, uint32 *hash)
+{
+	MinimalTuple	mtup;
+	size_t			nread;
+	uint32			head[2];
+	uint32			data_len;
+
+	/* Read hash value and tuple length */
+	nread = BufFileRead(bs->cur_batch_ptr, head, sizeof(head));
+	if (nread == 0)
+		return NULL;
+
+	if (nread != sizeof(head))
+		ereport(ERROR,
+				(errcode_for_file_access(),
+				 errmsg("could not read from batch store temporary file: %m")));
+	*hash = head[0];
+
+	/* Enlarge buffer and read tuple data */
+	enlargeStringInfo(&bs->hash_read_buf, head[1]);
+	mtup = (MinimalTuple)bs->hash_read_buf.data;
+	mtup->t_len = head[1];
+	data_len = head[1] - MINIMAL_TUPLE_DATA_OFFSET;
+	if (BufFileRead(bs->cur_batch_ptr, ((char*)mtup) + MINIMAL_TUPLE_DATA_OFFSET, data_len) != data_len)
+		ereport(ERROR,
+				(errcode_for_file_access(),
+				 errmsg("could not read from batch store temporary file: %m")));
+
+	return mtup;
+}
+
+/* end write batch store, ready for read */
+void
+bs_end_write(BatchStore bs)
+{
+	uint32 i;
+	switch(bs->method)
+	{
+	case BSM_HASH:
+		/* nothing to do */
+		break;
+	case BSM_PARALLEL_HASH:
+		for (i=bs->num_batches;i>0;)
+			sts_end_write(bs->all_batches[--i]);
+		bs->cur_batch_ptr = NULL;
+		break;
+	default:
+		ereport(ERROR,
+				(errmsg("unknown batch store method %u", bs->method)));
+		break;
+	}
+}
+
+/*
+ * Write MinimalTuple and hash value to parallel batch store
+ */
+static void
+bs_write_parallel_hash(BatchStore bs, MinimalTuple mtup, uint32 hash)
+{
+	sts_puttuple(bs->all_batches[hash%bs->num_batches],
+				 &hash,
+				 mtup);
+}
+
+/*
+ * Write MinimalTuple and hash value to parallel batch store,
+ * only for only have one batch
+ */
+static void
+bs_write_parallel_one_batch_hash(BatchStore bs, MinimalTuple mtup, uint32 hash)
+{
+	Assert(bs->num_batches == 1);
+	sts_puttuple(bs->all_batches[0],
+				 &hash,
+				 mtup);
+}
+
+/*
+ * Read MinimalTuple and hash value from parallel batch store
+ */
+static MinimalTuple
+bs_read_parallel_hash(BatchStore bs, uint32 *hash)
+{
+	return sts_scan_next(bs->cur_batch_ptr, hash);
+}
+
+/*
+ * Get next batch from batch store, return false if no more.
+ */
+bool
+bs_next_batch(BatchStore bs, bool no_parallel)
+{
+	uint32 batch;
+	switch(bs->method)
+	{
+	case BSM_HASH:
+
+		batch = bs->cur_batch_num;
+		++batch;
+
+		for (;batch < bs->num_batches;++batch)
+		{
+			if (bs->all_batches[batch])
+			{
+				bs->cur_batch_ptr = bs->all_batches[batch];
+				bs->cur_batch_num = batch;
+				if (BufFileSeek(bs->cur_batch_ptr, 0, 0, SEEK_SET) != 0)
+				{
+					ereport(ERROR,
+							(errcode_for_file_access(),
+							 errmsg("can not seek batch store file to head")));
+				}
+				return true;
+			}
+		}
+		break;
+	case BSM_PARALLEL_HASH:
+		if (no_parallel)
+		{
+			batch = bs->cur_batch_num;
+			++batch;
+		}else
+		{
+			batch = pg_atomic_add_fetch_u32(bs->shm_ph_batch_num, 1);
+		}
+
+		if (batch < bs->num_batches)
+		{
+			bs->cur_batch_num = batch;
+			bs->cur_batch_ptr = bs->all_batches[batch];
+			sts_begin_scan(bs->cur_batch_ptr);
+			return true;
+		}
+		break;
+	default:
+		ereport(ERROR,
+				(errmsg("unknown batch store method %u", bs->method)));
+		break;
+	}
+
+	return false;
+}
+
+void
+bs_rescan(BatchStore bs)
+{
+	switch(bs->method)
+	{
+	case BSM_HASH:
+		break;
+	case BSM_PARALLEL_HASH:
+		for (uint32 i=bs->num_batches;i>0;)
+			sts_reinitialize(bs->all_batches[--i]);
+		pg_atomic_write_u32(bs->shm_ph_batch_num, InvalidBatch);
+		break;
+	default:
+		ereport(ERROR,
+				(errmsg("unknown batch store method %u", bs->method)));
+		break;
+	}
+	bs->cur_batch_ptr = NULL;
+	bs->cur_batch_num = InvalidBatch;
+}
+
+/*
+ * Delete all the contents of a batch store
+ */
+void
+bs_clear(BatchStore bs)
+{
+	uint32	i;
+	switch (bs->method)
+	{
+	case BSM_HASH:
+		for (i=bs->num_batches;i>0;)
+		{
+			--i;
+			if (bs->all_batches[i])
+			{
+				BufFileClose(bs->all_batches[i]);
+				bs->all_batches[i] = 0;
+			}
+		}
+		break;
+	case BSM_PARALLEL_HASH:
+		pg_atomic_write_u32(bs->shm_ph_batch_num, InvalidBatch);
+		for (i=bs->num_batches;i>0;)
+			sts_clear(bs->all_batches[--i]);
+		break;
+	default:
+		ereport(ERROR,
+				(errmsg("unknown batch store method %u", bs->method)));
+		break;
+	}
+	bs->cur_batch_ptr = NULL;
+	bs->cur_batch_num = InvalidBatch;
+}
+
+void
+bs_end_cur_batch(BatchStore bs)
+{
+	switch(bs->method)
+	{
+	case BSM_HASH:
+		bs->cur_batch_ptr = NULL;
+		break;
+	case BSM_PARALLEL_HASH:
+		sts_end_scan(bs->cur_batch_ptr);
+		bs->cur_batch_ptr = NULL;
+		break;
+	default:
+		ereport(ERROR,
+				(errmsg("unknown batch store method %u", bs->method)));
+		break;
+	}
+}
diff --git a/src/backend/utils/sort/sharedtuplestore.c b/src/backend/utils/sort/sharedtuplestore.c
index 57e35db4f8..03472c080e 100644
--- a/src/backend/utils/sort/sharedtuplestore.c
+++ b/src/backend/utils/sort/sharedtuplestore.c
@@ -24,9 +24,10 @@
 #include "access/htup.h"
 #include "access/htup_details.h"
 #include "miscadmin.h"
+#include "port/atomics.h"
 #include "storage/buffile.h"
-#include "storage/lwlock.h"
 #include "storage/sharedfileset.h"
+#include "utils/memutils.h"
 #include "utils/sharedtuplestore.h"
 
 /*
@@ -50,8 +51,7 @@ typedef struct SharedTuplestoreChunk
 /* Per-participant shared state. */
 typedef struct SharedTuplestoreParticipant
 {
-	LWLock		lock;
-	BlockNumber read_page;		/* Page number for next read. */
+	pg_atomic_uint32 read_page;	/* Page number for next read. */
 	BlockNumber npages;			/* Number of pages written. */
 	bool		writing;		/* Used only for assertions. */
 } SharedTuplestoreParticipant;
@@ -72,6 +72,8 @@ struct SharedTuplestore
 struct SharedTuplestoreAccessor
 {
 	int			participant;	/* My participant number. */
+	bool		is_read_only;	/* is read only attach? */
+	bool		is_normal_scan;	/* is not parallel scan? */
 	SharedTuplestore *sts;		/* The shared state. */
 	SharedFileSet *fileset;		/* The SharedFileSet holding files. */
 	MemoryContext context;		/* Memory context for buffers. */
@@ -155,9 +157,8 @@ sts_initialize(SharedTuplestore *sts, int participants,
 
 	for (i = 0; i < participants; ++i)
 	{
-		LWLockInitialize(&sts->participants[i].lock,
-						 LWTRANCHE_SHARED_TUPLESTORE);
-		sts->participants[i].read_page = 0;
+		pg_atomic_init_u32(&sts->participants[i].read_page, 0);
+		sts->participants[i].npages = 0;
 		sts->participants[i].writing = false;
 	}
 
@@ -192,6 +193,27 @@ sts_attach(SharedTuplestore *sts,
 	return accessor;
 }
 
+/*
+ * Like function sts_attach, but only for read, can't write any tuple
+ */
+SharedTuplestoreAccessor *
+sts_attach_read_only(SharedTuplestore *sts,
+					 SharedFileSet *fileset)
+{
+	SharedTuplestoreAccessor *accessor;
+
+	Assert(sts->nparticipants > 0);
+
+	accessor = palloc0(sizeof(SharedTuplestoreAccessor));
+	accessor->is_read_only = true;
+	accessor->participant = 0;
+	accessor->sts = sts;
+	accessor->fileset = fileset;
+	accessor->context = CurrentMemoryContext;
+
+	return accessor;
+}
+
 static void
 sts_flush_chunk(SharedTuplestoreAccessor *accessor)
 {
@@ -242,10 +264,42 @@ sts_reinitialize(SharedTuplestoreAccessor *accessor)
 	 */
 	for (i = 0; i < accessor->sts->nparticipants; ++i)
 	{
-		accessor->sts->participants[i].read_page = 0;
+		pg_atomic_init_u32(&accessor->sts->participants[i].read_page, 0);
 	}
 }
 
+/*
+ * Delete all the contents of shared tuplestore, and reset read page to the start
+ */
+void
+sts_clear(SharedTuplestoreAccessor *accessor)
+{
+	int					i;
+	char				name[MAXPGPATH];
+	SharedTuplestore   *sts = accessor->sts;
+
+	/* Must not in read and write */
+	Assert(accessor->read_file == NULL &&
+		   accessor->write_file == NULL);
+
+	/* Delete all created files */
+	for (i=0;i<sts->nparticipants;++i)
+	{
+		Assert(sts->participants[i].writing == false);
+		if (sts->participants[i].npages > 0)
+		{
+			sts_filename(name, accessor, i);
+			BufFileDeleteShared(accessor->fileset, name);
+			pg_atomic_write_u32(&sts->participants[i].read_page, 0);
+			sts->participants[i].npages = 0;
+		}
+	}
+
+	accessor->write_page = 0;
+	accessor->write_pointer = NULL;
+	accessor->write_end = NULL;
+}
+
 /*
  * Begin scanning the contents in parallel.
  */
@@ -272,6 +326,8 @@ sts_begin_parallel_scan(SharedTuplestoreAccessor *accessor)
 	accessor->read_participant = accessor->participant;
 	accessor->read_file = NULL;
 	accessor->read_next_page = 0;
+	accessor->read_ntuples = 0;
+	accessor->read_ntuples_available = 0;
 }
 
 /*
@@ -302,15 +358,23 @@ sts_puttuple(SharedTuplestoreAccessor *accessor, void *meta_data,
 {
 	size_t		size;
 
+	if (unlikely(accessor->is_read_only))
+	{
+		ereport(ERROR,
+				(errmsg("shard tuplestore is attached read only")));
+	}
+
 	/* Do we have our own file yet? */
 	if (accessor->write_file == NULL)
 	{
 		SharedTuplestoreParticipant *participant;
-		char		name[MAXPGPATH];
+		char			name[MAXPGPATH];
+		MemoryContext	oldcontext = MemoryContextSwitchTo(accessor->context);
 
 		/* Create one.  Only this backend will write into it. */
 		sts_filename(name, accessor, accessor->participant);
 		accessor->write_file = BufFileCreateShared(accessor->fileset, name);
+		MemoryContextSwitchTo(oldcontext);
 
 		/* Set up the shared state for this backend's file. */
 		participant = &accessor->sts->participants[accessor->participant];
@@ -532,20 +596,36 @@ sts_parallel_scan_next(SharedTuplestoreAccessor *accessor, void *meta_data)
 		/* Find the location of a new chunk to read. */
 		p = &accessor->sts->participants[accessor->read_participant];
 
-		LWLockAcquire(&p->lock, LW_EXCLUSIVE);
-		/* We can skip directly past overflow pages we know about. */
-		if (p->read_page < accessor->read_next_page)
-			p->read_page = accessor->read_next_page;
-		eof = p->read_page >= p->npages;
-		if (!eof)
+		if (accessor->is_normal_scan)
+		{
+			eof = accessor->read_next_page >= p->npages;
+			if (!eof)
+			{
+				read_page = accessor->read_next_page;
+				accessor->read_next_page += STS_CHUNK_PAGES;
+			}
+		}else
 		{
 			/* Claim the next chunk. */
-			read_page = p->read_page;
-			/* Advance the read head for the next reader. */
-			p->read_page += STS_CHUNK_PAGES;
-			accessor->read_next_page = p->read_page;
+			read_page = pg_atomic_read_u32(&p->read_page);
+			/* We can skip directly past overflow pages we know about. */
+			while (read_page < accessor->read_next_page)
+			{
+				if (pg_atomic_compare_exchange_u32(&p->read_page,
+												   &read_page,
+												   accessor->read_next_page))
+					break;
+			}
+			while ((eof = read_page >= p->npages) == false)
+			{
+				/* Advance the read head for the next reader. */
+				accessor->read_next_page = read_page + STS_CHUNK_PAGES;
+				if (pg_atomic_compare_exchange_u32(&p->read_page,
+												   &read_page,
+												   accessor->read_next_page))
+					break;
+			}
 		}
-		LWLockRelease(&p->lock);
 
 		if (!eof)
 		{
@@ -556,10 +636,12 @@ sts_parallel_scan_next(SharedTuplestoreAccessor *accessor, void *meta_data)
 			if (accessor->read_file == NULL)
 			{
 				char		name[MAXPGPATH];
+				MemoryContext oldcontext = MemoryContextSwitchTo(accessor->context);
 
 				sts_filename(name, accessor, accessor->read_participant);
 				accessor->read_file =
 					BufFileOpenShared(accessor->fileset, name, O_RDONLY);
+				MemoryContextSwitchTo(oldcontext);
 			}
 
 			/* Seek and load the chunk header. */
@@ -626,3 +708,46 @@ sts_filename(char *name, SharedTuplestoreAccessor *accessor, int participant)
 {
 	snprintf(name, MAXPGPATH, "%s.p%d", accessor->sts->name, participant);
 }
+
+/*
+ * Begin scanning the contents.
+ */
+void
+sts_begin_scan(SharedTuplestoreAccessor *accessor)
+{
+	sts_begin_parallel_scan(accessor);
+	accessor->is_normal_scan = true;
+}
+
+/*
+ * Finish a normal scan, freeing associated backend-local resources.
+ */
+void
+sts_end_scan(SharedTuplestoreAccessor *accessor)
+{
+	Assert(accessor->is_normal_scan);
+	sts_end_parallel_scan(accessor);
+	accessor->is_normal_scan = false;
+}
+
+/*
+ * Get the next tuple in the current normal scan.
+ */
+MinimalTuple
+sts_scan_next(SharedTuplestoreAccessor *accessor,
+					   void *meta_data)
+{
+	Assert(accessor->is_normal_scan);
+	return sts_parallel_scan_next(accessor, meta_data);
+}
+
+/*
+ * Detach SharedTuplestore and freeing associated backend-local resources.
+ */
+void
+sts_detach(SharedTuplestoreAccessor *accessor)
+{
+	sts_end_write(accessor);
+	sts_end_parallel_scan(accessor);
+	pfree(accessor);
+}
diff --git a/src/backend/utils/sort/tuplesort.c b/src/backend/utils/sort/tuplesort.c
index 7d0f96afb7..fc38d26a68 100644
--- a/src/backend/utils/sort/tuplesort.c
+++ b/src/backend/utils/sort/tuplesort.c
@@ -4573,6 +4573,26 @@ tuplesort_initialize_shared(Sharedsort *shared, int nWorkers, dsm_segment *seg)
 	}
 }
 
+/*
+ * tuplesort_reset_shared - reset shared tuplesort state
+ *
+ * Must be called from leader process before workers are launched,
+ * can be reuse after this call
+ */
+void
+tuplesort_reset_shared(Sharedsort *shared)
+{
+	int			i;
+
+	shared->currentWorker = 0;
+	shared->workersFinished = 0;
+	SharedFileSetDeleteAll(&shared->fileset);
+	for (i = 0; i < shared->nTapes; i++)
+	{
+		shared->tapes[i].firstblocknumber = 0L;
+	}
+}
+
 /*
  * tuplesort_attach_shared - attach to shared tuplesort state
  *
diff --git a/src/include/executor/nodeAgg.h b/src/include/executor/nodeAgg.h
index 398446d11f..68b277b379 100644
--- a/src/include/executor/nodeAgg.h
+++ b/src/include/executor/nodeAgg.h
@@ -310,6 +310,8 @@ typedef struct AggStatePerHashData
 	int			largestGrpColIdx;	/* largest col required for hashing */
 	AttrNumber *hashGrpColIdxInput; /* hash col indices in input slot */
 	AttrNumber *hashGrpColIdxHash;	/* indices in hash table tuples */
+	Bitmapset  *colnos_needed;	/* all columns needed from the outer plan */
+	struct BatchStoreData *batch_store;	/* grouping set batch store hash */
 	Agg		   *aggnode;		/* original Agg node, for numGroups etc. */
 }			AggStatePerHashData;
 
diff --git a/src/include/executor/nodeBatchSort.h b/src/include/executor/nodeBatchSort.h
new file mode 100644
index 0000000000..66c68e0125
--- /dev/null
+++ b/src/include/executor/nodeBatchSort.h
@@ -0,0 +1,19 @@
+
+#ifndef NODE_BATCH_SORT_H
+#define NODE_BATCH_SORT_H
+
+#include "access/parallel.h"
+#include "nodes/execnodes.h"
+
+extern BatchSortState *ExecInitBatchSort(BatchSort *node, EState *estate, int eflags);
+extern void ExecEndBatchSort(BatchSortState *node);
+extern void ExecReScanBatchSort(BatchSortState *node);
+
+/* parallel scan support */
+extern void ExecBatchSortEstimate(BatchSortState *node, ParallelContext *pcxt);
+extern void ExecBatchSortInitializeDSM(BatchSortState *node, ParallelContext *pcxt);
+extern void ExecBatchSortReInitializeDSM(BatchSortState *node, ParallelContext *pcxt);
+extern void ExecBatchSortInitializeWorker(BatchSortState *node, ParallelWorkerContext *pwcxt);
+extern void ExecShutdownBatchSort(BatchSortState *node);
+
+#endif							/* NODE_BATCH_SORT_H */
\ No newline at end of file
diff --git a/src/include/nodes/execnodes.h b/src/include/nodes/execnodes.h
index 48c3f570fa..8ad2a24ab7 100644
--- a/src/include/nodes/execnodes.h
+++ b/src/include/nodes/execnodes.h
@@ -2011,6 +2011,22 @@ typedef struct SortState
 	SharedSortInfo *shared_info;	/* one entry per worker */
 } SortState;
 
+/* ----------------
+ *	 BatchSortState information
+ * ----------------
+ */
+typedef struct BatchSortState
+{
+	PlanState	ps;				/* its first field is NodeTag */
+	struct Tuplesortstate
+			  **batches;		/* private state of tuplesort.c */
+	List	   *groupFuns;		/* hash function call info for each group-key */
+	struct ParallelBatchSort
+			   *parallel;		/* parallel info, private in nodeBatchSort.c */
+	int			curBatch;		/* current batch index */
+	bool		sort_Done;		/* sort completed yet? */
+}BatchSortState;
+
 /* ----------------
  *	 Instrumentation information for IncrementalSort
  * ----------------
@@ -2202,6 +2218,9 @@ typedef struct AggState
 										 * ->hash_pergroup */
 	ProjectionInfo *combinedproj;	/* projection machinery */
 	SharedAggInfo *shared_info; /* one entry per worker */
+	struct Barrier *batch_barrier;		/* for parallel batch */
+	int			current_batch_set;		/* current batch grouping set */
+	bool		batch_filled;			/* is all batches filled? */
 } AggState;
 
 /* ----------------
diff --git a/src/include/nodes/nodes.h b/src/include/nodes/nodes.h
index caed683ba9..8da83c7269 100644
--- a/src/include/nodes/nodes.h
+++ b/src/include/nodes/nodes.h
@@ -74,6 +74,7 @@ typedef enum NodeTag
 	T_HashJoin,
 	T_Material,
 	T_Sort,
+	T_BatchSort,
 	T_IncrementalSort,
 	T_Group,
 	T_Agg,
@@ -131,6 +132,7 @@ typedef enum NodeTag
 	T_HashJoinState,
 	T_MaterialState,
 	T_SortState,
+	T_BatchSortState,
 	T_IncrementalSortState,
 	T_GroupState,
 	T_AggState,
@@ -245,6 +247,7 @@ typedef enum NodeTag
 	T_ProjectionPath,
 	T_ProjectSetPath,
 	T_SortPath,
+	T_BatchSortPath,
 	T_IncrementalSortPath,
 	T_GroupPath,
 	T_UpperUniquePath,
@@ -759,7 +762,8 @@ typedef enum AggStrategy
 	AGG_PLAIN,					/* simple agg across all input rows */
 	AGG_SORTED,					/* grouped agg, input must be sorted */
 	AGG_HASHED,					/* grouped agg, use internal hashtable */
-	AGG_MIXED					/* grouped agg, hash and sort both used */
+	AGG_MIXED,					/* grouped agg, hash and sort both used */
+	AGG_BATCH_HASH				/* grouped agg, use batch hash */
 } AggStrategy;
 
 /*
diff --git a/src/include/nodes/pathnodes.h b/src/include/nodes/pathnodes.h
index cde2637798..2db484a7da 100644
--- a/src/include/nodes/pathnodes.h
+++ b/src/include/nodes/pathnodes.h
@@ -1654,6 +1654,16 @@ typedef struct SortPath
 	Path	   *subpath;		/* path representing input source */
 } SortPath;
 
+typedef struct BatchSortPath
+{
+	Path		path;
+	Path	   *subpath;		/* path representing input source */
+	List	   *batchkeys;		/* our result is not all ordered, only for each batch,
+								 * so we can not use Path::pathkeys */
+	List	   *batchgroup;		/* a list of SortGroupClause for hash */
+	uint32		numBatches;
+}BatchSortPath;
+
 /*
  * IncrementalSortPath represents an incremental sort step
  *
@@ -2500,6 +2510,7 @@ typedef struct
 	bool		target_parallel_safe;
 	Node	   *havingQual;
 	List	   *targetList;
+	List	   *hashable_groups;
 	PartitionwiseAggregateType patype;
 } GroupPathExtraData;
 
diff --git a/src/include/nodes/plannodes.h b/src/include/nodes/plannodes.h
index 43160439f0..675850de13 100644
--- a/src/include/nodes/plannodes.h
+++ b/src/include/nodes/plannodes.h
@@ -774,6 +774,19 @@ typedef struct Sort
 	bool	   *nullsFirst;		/* NULLS FIRST/LAST directions */
 } Sort;
 
+/* ----------------
+ *		batch sort node
+ * ----------------
+ */
+typedef struct BatchSort
+{
+	Sort		sort;
+	int			numGroupCols;	/* number of group-key columns */
+	int			numBatches;		/* number of group */
+	int			gather_param;	/* ID of Param of plan Gather or GatherMerge */
+	AttrNumber *grpColIdx;		/* their indexes in the target list */
+}BatchSort;
+
 /* ----------------
  *		incremental sort node
  * ----------------
@@ -828,6 +841,8 @@ typedef struct Agg
 	/* Note: planner provides numGroups & aggParams only in HASHED/MIXED case */
 	List	   *groupingSets;	/* grouping sets to use */
 	List	   *chain;			/* chained Agg/Sort nodes */
+	int			numBatches;		/* valid in AGG_BATCH_HASH */
+	int			gatherParam;	/* param of gather */
 } Agg;
 
 /* ----------------
diff --git a/src/include/optimizer/cost.h b/src/include/optimizer/cost.h
index ed2e4af4be..f44796ad68 100644
--- a/src/include/optimizer/cost.h
+++ b/src/include/optimizer/cost.h
@@ -66,6 +66,8 @@ extern PGDLLIMPORT bool enable_parallel_append;
 extern PGDLLIMPORT bool enable_parallel_hash;
 extern PGDLLIMPORT bool enable_partition_pruning;
 extern PGDLLIMPORT int constraint_exclusion;
+extern PGDLLIMPORT int max_sort_batches;
+extern PGDLLIMPORT int max_hashagg_batches;
 
 extern double index_pages_fetched(double tuples_fetched, BlockNumber pages,
 								  double index_pages, PlannerInfo *root);
@@ -102,6 +104,11 @@ extern void cost_sort(Path *path, PlannerInfo *root,
 					  List *pathkeys, Cost input_cost, double tuples, int width,
 					  Cost comparison_cost, int sort_mem,
 					  double limit_tuples);
+extern void cost_batchsort(Path *path, PlannerInfo *root,
+						   List *batchkeys, Cost input_cost,
+						   double tuples, int width,
+						   Cost comparison_cost, int sort_mem,
+						   uint32 numGroupCols, uint32 numBatchs);
 extern void cost_incremental_sort(Path *path,
 								  PlannerInfo *root, List *pathkeys, int presorted_keys,
 								  Cost input_startup_cost, Cost input_total_cost,
diff --git a/src/include/optimizer/pathnode.h b/src/include/optimizer/pathnode.h
index 23dec14cbd..9f87d71b95 100644
--- a/src/include/optimizer/pathnode.h
+++ b/src/include/optimizer/pathnode.h
@@ -195,6 +195,13 @@ extern IncrementalSortPath *create_incremental_sort_path(PlannerInfo *root,
 														 List *pathkeys,
 														 int presorted_keys,
 														 double limit_tuples);
+extern BatchSortPath *create_batchsort_path(PlannerInfo *root,
+											RelOptInfo *rel,
+											Path *subpath,
+											List *pathkeys,
+											List *groupClause,
+											uint32 numBatches,
+											bool parallel_sort);
 extern GroupPath *create_group_path(PlannerInfo *root,
 									RelOptInfo *rel,
 									Path *subpath,
diff --git a/src/include/optimizer/tlist.h b/src/include/optimizer/tlist.h
index e081ef2d5e..188a91e0c2 100644
--- a/src/include/optimizer/tlist.h
+++ b/src/include/optimizer/tlist.h
@@ -36,6 +36,7 @@ extern Oid *extract_grouping_collations(List *groupClause, List *tlist);
 extern AttrNumber *extract_grouping_cols(List *groupClause, List *tlist);
 extern bool grouping_is_sortable(List *groupClause);
 extern bool grouping_is_hashable(List *groupClause);
+extern List *grouping_get_hashable(List *groupClause);
 
 extern PathTarget *make_pathtarget_from_tlist(List *tlist);
 extern List *make_tlist_from_pathtarget(PathTarget *target);
diff --git a/src/include/pgstat.h b/src/include/pgstat.h
index c38b689710..67138fa566 100644
--- a/src/include/pgstat.h
+++ b/src/include/pgstat.h
@@ -964,7 +964,9 @@ typedef enum
 	WAIT_EVENT_REPLICATION_SLOT_DROP,
 	WAIT_EVENT_SAFE_SNAPSHOT,
 	WAIT_EVENT_SYNC_REP,
-	WAIT_EVENT_XACT_GROUP_UPDATE
+	WAIT_EVENT_XACT_GROUP_UPDATE,
+	WAIT_EVENT_BATCH_SORT_BUILD,
+	WAIT_EVENT_BATCH_HASH_BUILD
 } WaitEventIPC;
 
 /* ----------
diff --git a/src/include/storage/lwlock.h b/src/include/storage/lwlock.h
index cbf2510fbf..cee0a540c9 100644
--- a/src/include/storage/lwlock.h
+++ b/src/include/storage/lwlock.h
@@ -214,7 +214,6 @@ typedef enum BuiltinTrancheIds
 	LWTRANCHE_PER_SESSION_DSA,
 	LWTRANCHE_PER_SESSION_RECORD_TYPE,
 	LWTRANCHE_PER_SESSION_RECORD_TYPMOD,
-	LWTRANCHE_SHARED_TUPLESTORE,
 	LWTRANCHE_SHARED_TIDBITMAP,
 	LWTRANCHE_PARALLEL_APPEND,
 	LWTRANCHE_PER_XACT_PREDICATE_LIST,
diff --git a/src/include/utils/batchstore.h b/src/include/utils/batchstore.h
new file mode 100644
index 0000000000..f8d276a0d7
--- /dev/null
+++ b/src/include/utils/batchstore.h
@@ -0,0 +1,38 @@
+#ifndef BATCH_STORE_H
+#define BATCH_STORE_H
+
+#include "access/htup.h"
+#include "storage/dsm.h"
+#include "storage/sharedfileset.h"
+
+typedef struct BatchStoreData* BatchStore;
+typedef struct BatchStoreParallelHashData* BatchStoreParallelHash;
+
+typedef struct BatchStoreFuncs
+{
+	void (*hash_write)(BatchStore bs, MinimalTuple mtup, uint32 hash);
+	MinimalTuple (*hash_read)(BatchStore bs, uint32 *hash);
+}BatchStoreFuncs;
+
+#define bs_write_hash(bs, mtup, hash) (*((BatchStoreFuncs*)bs)->hash_write)(bs, mtup, hash)
+#define bs_read_hash(bs, phash) (*((BatchStoreFuncs*)bs)->hash_read)(bs, phash)
+
+extern BatchStore bs_begin_hash(uint32 num_batches);
+
+extern size_t bs_parallel_hash_estimate(uint32 num_batches, uint32 nparticipants);
+extern BatchStore bs_init_parallel_hash(uint32 num_batches,
+										uint32 nparticipants, uint32 my_participant_num,
+										BatchStoreParallelHash bsph, dsm_segment *dsm_seg,
+										SharedFileSet *fileset, const char *name);
+extern BatchStore bs_attach_parallel_hash(BatchStoreParallelHash bsph, dsm_segment *dsm_seg,
+										  SharedFileSet *fileset, uint32 my_participant_num);
+
+extern void bs_destory(BatchStore bs);
+extern void bs_clear(BatchStore bs);
+
+extern void bs_end_write(BatchStore bs);
+
+extern bool bs_next_batch(BatchStore bs, bool no_parallel);
+extern void bs_rescan(BatchStore bs);
+extern void bs_end_cur_batch(BatchStore bs);
+#endif /* BATCH_STORE_H */
\ No newline at end of file
